<?

/**
 ** tag: autore
 ** desc: estrae il nome dell'autore  della pagina
 ** opt: title stringa per attributo title del link mailto. formato: 'testo %s testo', dove %s sara` sostituito col nome dell'autore
 ** opt: class nome classe css
 **/
function autore ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['title']))
        $options['title'] = 'Mail to %s';

    if (trim($options['class']))
        $options['class'] = "class=\"".$options['class']."\"";

    $rs = $connh->Execute("SELECT nome, email FROM user WHERE username='".$row['id_user']."'");
    if ($rs->fields['email'])
        $subst = "<a title=\"".sprintf($options['title'], $rs->fields['nome'])."\" href=\"mailto:".$rs->fields['email']."\" ".$options['class'].">".$rs->fields['nome']."</a>";
    else
        $subst = $rs->fields['nome'];

    // return an output string
    return $subst;
}

/**
 ** tag: lastmod
 ** desc: stampa la data di ultima modifica della pagina
 ** opt: format stringa di formattazione della data (vedi http://it.php.net/manual/it/function.strftime.php)
 ** eg: {lastmod format="%m-%d-%Y"} stampa mese-giorno-anno: 09-13-2007
 ** eg: {lastmod} senza parametro format stampa giorno-mese-anno: 13-09-2007
 **/
function lastmod ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['format']))
        $options['format'] = "%d-%m-%Y";

    return strftime($options['format'], strtotime($row['lastmod']));
}

/**
 ** tag: created
 ** desc: stampa la data di creazione della pagina
 ** opt: format stringa di formattazione della data (vedi http://it.php.net/manual/it/function.strftime.php)
 ** eg: {lastmod format="%m-%d-%Y"} stampa mese-giorno-anno: 09-13-2007
 ** eg: {lastmod} senza parametro format stampa giorno-mese-anno: 13-09-2007
 **/
function created ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['format']))
        $options['format'] = "%d-%m-%Y";

    return strftime($options['format'], strtotime($row['creation']));
}

/**
 ** tag: getidparent
 ** desc: ritorna l'id_parent della pagina specificata
 ** opt: target l'id della pagina di cui si vuole sapere l'id_parent
 ** eg: {getidparent target="7"}
 ** eg: {getidparent} torna id_parent della pagina corrente
 **/
function getidparent ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['target']))
        return $row['id_parent'];
    else {
        $rs = $connh->Execute("SELECT id_parent FROM node WHERE id='".$options['target']."' LIMIT 1");
        if ($rs->RecordCount())
            return $rs->fields['id_parent'];
    }
}

/**
 ** tag: getnodeinfo
 ** desc: ritorna l'info di struttura o contenuto per l'id specificato
 ** opt: target l'id della pagina di cui si vuole sapere l'info
 ** opt: type struct|content tipo di info riochiesta (default struct)
 ** opt: field campo richiesto
 ** eg: {getnodeinfo target="7" type="content" field="titolo"}
 **/
function getnodeinfo ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['target']) || !is_numeric($options['target']) || !trim($options['field']))
        return '';

    if (!trim($options['type']))
        $options['type'] = 'struct';

    $rs = $connh->Execute("SELECT * FROM node WHERE id='".$options['target']."'");
    if ($options['type'] == 'struct')
        return $rs->fields[$options['field']];
    else {
        $rsc = $connh->Execute("SELECT * FROM `".$rs->fields['contenuto']."` WHERE id='".$options['target']."'");
        return $rsc->fields[$options['field']];
    }
}


/**
 ** tag: counter
 ** desc: calcola il numero di click totali o parziali del sito
 ** opt: target id della pagina da cui estrarre la conta dei click
 ** opt: count puo` assumere valori ric|sons o vuoto. ric calcola i click di tutti i figli di target ricorsivamente; sons calcola i click dei figli di target; se non viene fornito il parametro count, si contano solo i click della pagina con id target
 **/
function counter ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    static $ricount = 0;

    if (!trim($options['target']))
        $options['target'] = $row['id'];

    switch (trim($options['count'])) {
        case 'sons':
            $query = "SELECT SUM(visite) AS s FROM node WHERE id_parent='".$options['target']."' or id='".$options['target']."'";
            $rs = $connh->Execute($query);
            $subst = $rs->fields['s'];
        break;
        case 'ric':
            if (!$ricount) {
                $query = "SELECT visite AS s  FROM node WHERE id='".$options['target']."'";
                $rs = $connh->Execute($query);
                $ricount += $rs->fields['s'];
            }
            $query = "SELECT * FROM node WHERE id_parent='".$options['target']."'";
            $rs = $connh->Execute($query);
            while (!$rs->EOF) {
                $query = "SELECT visite AS s  FROM node WHERE id='".$rs->fields['id']."'";
                $rsc = $connh->Execute($query);
                $ricount += $rsc->fields['s'];
                $options['target'] = $rs->fields['id'];
                counter($connh, $row, $PRISCILLA_SESSION, $options);
                $rs->MoveNext();
            }
            $subst = $ricount;
        break;
        default:
            $query = "SELECT visite AS s FROM node WHERE id='".$options['target']."'";
            $rs = $connh->Execute($query);
            $subst = $rs->fields['s'];
        break;
    }

    unset($ricount);
    return $subst;
}

/**
 ** tag: tree
 ** desc: stampa l'albero del sito
 ** opt: target id della pagina da cui cominciare l'albero. se non impostato si parte dalla index
 ** opt: taglist tag xhtml da utilizzare per la lista, default ul
 ** opt: tagitem tag xhtml da utilizzare per un elemento della lista, default li
 ** opt: order_field campo di ordinamento, default rilevanza
 ** opt: order_dir direzione di ordinamento (asc|desc), default asc
 **/
function tree ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    static $ret = '';

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;


    if (!$options['target'])
        $options['target'] = 0;

    if (!$options['taglist'])
        $options['taglist'] = 'ul';
    if (!$options['tagitem'])
        $options['tagitem'] = 'li';

    if (!$options['order_field'])
        $options['order_field'] = 'rilevanza';
    if (!$options['order_dir'])
        $options['order_dir'] = 'asc';

    $query = "SELECT * FROM node WHERE id_parent='".$options['target']."' and pubblicazione='pubblica' ORDER BY ".$options['order_field']." ".$options['order_dir'];
    $rs = $connh->Execute($query);
    
    if ($rs->RecordCount() > 0) {
        $ret .= "\n<".$options['taglist']." class=\"sitemap\">";
        while (!$rs->EOF) {
            if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
                $rs->fields['contenuto'] = $rs->fields['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

            $rsc = $connh->Execute("SELECT titolo FROM `".$rs->fields['contenuto']."` WHERE id='".$rs->fields['id']."'");
        
            if ($have_seo)
                $index_page = maketitle($rs->fields('id'), seotitle($rsc->fields('titolo')));
            else
                $index_page = "index.php?id=" . $rs->fields['id'];
            

            $ret .= "\n<".$options['tagitem']."><a title=\"".$rsc->fields['titolo']."\" href=\"" . $index_page . "\">".$rsc->fields['titolo']."</a>";

            $options['target'] = $rs->fields['id'];
            tree($connh, $row, $PRISCILLA_SESSION, $options);

            $ret .= "</".$options['tagitem'].">\n";

            $rs->MoveNext();
        }
        $ret .= "</".$options['taglist'].">";
    }

    return $ret;
}

/**
 ** tag: linka
 ** desc: genera un link html ad una pagina del sito
 ** opt: target id della pagina del sito che si vuole linkare oppure indirizzo url esterno
 ** opt: text testo del link, se non impostato viene utilizzato il nome di sezione o l'url dato a target
 ** opt: class classe css applicata al tag a generato
 ** opt: title attributo title del tag a, se non impostato si utilizza text
 **/
function linka ($connh, $row, &$PRISCILLA_SESSION, $options)
{


    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    $subst = '';
    if (is_numeric($options['target'])) {
        $query = "SELECT contenuto, sezione FROM node WHERE id='".$options['target']."'";
        $rs = $connh->Execute($query);

        if ($rs->RecordCount() > 0) {
            // se abbiamo definito un campo per il testo del link
            if (!trim($options['text']))
                $options['text'] = $rs->fields['sezione'];
        
            if (!trim($options['title']))
                $options['title'] = $options['text'];

            if (trim($options['class']))
                $options['class'] = "class=\"".$options['class']."\"";

            if ($have_seo)
                $s_href = maketitle($options['target'],  gettitle($options['target'], $connh));
            else
                $s_href = "index.php?id=". $options['target'];

            $subst .= "<a title=\"".$options['title']."\" href=\"" .  $s_href . "\" " . $options['class'].">".$options['text']."</a>";
        }
    }
    elseif (is_string($options['target'])) {
        if (!trim($options['text']))
            $options['text'] = $options['target'];
    
        if (!trim($options['title']))
            $options['title'] = $options['text'];

        if (trim($options['class']))
            $options['class'] = "class=\"".$options['class']."\"";

        $options['target'] = check_url($options['target']);

        $subst .= "<a title=\"".$options['title']."\" href=\"".$options['target']."\" ".$options['class'].">".$options['text']."</a>";
    }

    return $subst;
}

/** 
 ** tag: path
 ** desc: visualizza il percorso seguendo l'albero del sito
 ** opt: target comincia il percorso da quell'id, se non impostato parte da index
 ** opt: separator carattere separatore tra le sezioni ( default &gt; )
 ** opt: class classe css applicata al tag a generato
 **/
function path ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!$options['target'])
        $options['target'] = 1;

    if (!$options['separator'])
        $options['separator'] = '&gt;';

    if (trim($options['class']))
        $options['class'] = "class=\"".$options['class']."\"";

    if (trim($options['separatorclass']))
        $options['separatorclass'] = "class=\"".$options['class']."\"";

    $subst = '';

    $nid = $row['id'];


    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    while ($nid > 0) {
        if ($options['target'] != 1 && $options['target'] == $idp)
            break;

        $query = "SELECT id, id_parent, contenuto FROM node WHERE id='".$nid."'";
        $rs = $connh->Execute($query);

        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
            $rs->fields['contenuto'] = $rs->fields['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $rsc = $connh->Execute("SELECT titolo FROM `".$rs->fields['contenuto']."` WHERE id='".$nid."'");

        if ($have_seo)
            $index_page = maketitle($nid, seotitle($rsc->fields('titolo')));
        else
            $index_page = "index.php?id=" . $nid;

        if ($nid != $_GET['id'])
            $subst = "<a title=\"".$rsc->fields['titolo']."\" href=\"" . $index_page . "\" ".$options['class'].">".$rsc->fields['titolo']."</a> <span ".$options['separatorclass'].">".$options['separator']."</span> ".$subst;
        else
            $subst = $rsc->fields['titolo']." ".$subst;

        $idp = $nid;
        $nid = $rs->fields['id_parent'];
    }
    
    return $subst;
}

/**
 ** tag: betty
 ** desc: stampa alcune variabili relative al software priscilla
 ** opt: get puo` assumere valori logo|nome|login|home|contact|url|versione
 **/
function priscilla ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $goodkeys = array('logo', 'nome', 'login', 'home', 'contact', 'url', 'versione');

    if (in_array($options['get'], $goodkeys)) {
        $rs = select("SELECT `".$options['get']."` FROM betty LIMIT 0,1", $connh);
        return $rs->fields[$options['get']];
    }
    else return '';
}

/**
 ** tag: allegato
 ** desc: inserisce un link per permettere il download di un allegato
 ** opt: id identificativo numerico dell'allegato da richiamare
 ** opt: desc (true|false) se impostato a true usa la descrizione come nome del file
 ** opt: class nome classe di stile css da applicare al link
 **/
function allegato ($connh, $row, &$DATATONIC_SESSION, $options)
{

    $path = "";
    $nomefile = "";
    $stiletext = "";

    $my_id = $options['id'];

    if (trim($options['class']) != '')
        $stiletext = " class=\"" . $options['class'] . "\"";

    if ($options['desc'] == "true")
        $wantdesc = true;
    else
        $wantdesc = false;

    if (is_numeric($my_id)) {

        // per andare a pigliare l'opzione sul tipo di download allegato
        $dbquery = "SELECT noattachscript FROM `priscilla`";
        $rowalle = $connh->Execute($dbquery) or die($dbquery. "<br />" . $connh->ErrorMsg());
        $noattachscript = $rowalle->fields('noattachscript');
        if (trim($noattachscript) == '')
            $noattachscript = "no";

        $query = "SELECT * FROM allegati WHERE id_allegato = '$my_id'";
        $rowrs1 = $connh->Execute($query);
        $azzrow = $rowrs1->fields;

            if (trim($azzrow['code']) != '' && !$GLOBALS[dumping] && $noattachscript == 'no') {
                if ($wantdesc && trim($azzrow['description']) != '')
                    $nomefile =  htmlentities($azzrow['description'], ENT_COMPAT, PRISCILLA_CHARSET);
                else
                    $nomefile = $azzrow['nome'];

                $path_allegato = PRISCILLA_SERVER_PATH .  "modules/core/lib/d.php?c=" . $azzrow['code'];
            }
            else {
                $path = "attach" . "/" . $azzrow[id_user] . "/" . $azzrow[tipo];
                if (trim($azzrow['gruppo']) != '')
                $path .= "/" . $azzrow['gruppo'];

                if ($wantdesc && trim($azzrow['description']) != '')
                    $nomefile =  htmlentities($azzrow['description'], ENT_COMPAT, PRISCILLA_CHARSET);
                else
                    $nomefile = $azzrow['nome'];



                $path_allegato = "$path/" .  $azzrow['nome'];
            }
    } // if (is_numeric


return "<a title=\"$nomefile\" href=\"$path_allegato\"$stiletext>$nomefile</a>";
}

/**
 ** tag: foto
 ** desc: stampa una foto memorizzata dal pannello
 ** opt: id id della foto da stampare (l'id si recupera dal pannello foto)
 ** opt: alias nome assegnato alla foto, modo alternativo a "id" per richiamare l'immagine
 ** opt: path (true | false) se posto a true da' in output il path all'immagine
 **/
function foto ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $close_label = array (
    'ita' => 'chiudi',
    'eng' => 'close',
    'esp' => 'cierra',
    'deu' => 'schlie&szlig;en'
    );

    $dialog_img_closepopup = $close_label[LANG];

    if ($options['id'])
        $query = "SELECT * FROM immagini WHERE id_image='".$options['id']."' LIMIT 0,1";
    else {
        $options['alias'] = strtolower($options['alias']);
        $query = "SELECT * FROM immagini WHERE alias='".$options['alias']."' LIMIT 0,1";
    }

    if ($options['path'] == true)
        $wantpath = true;
    else
        $wantpath = false;


    $rowrs1 = $connh->Execute($query);
    $rowf = $rowrs1->fields;
    
    if ($rowf[id_user]=='superuser') $dir='';
    else $dir = $rowf[id_user].'/';
    $src = "pix/$dir$rowf[nome]";

    if ($rowf['popup']) {
        if ($rowf['popup']{0} == 'f') {
            $idpop = substr($rowf['popup'], 1);
            $rowrs = $connh->Execute("SELECT * FROM flash WHERE id='".$idpop."'");
            $rowp = $rowrs->fields;
            $path = 'attach/'.$rowp['id_user'].'/flash/'.$rowp['path'];
            $rowp['nome'] = $rowp['title'];
            $modalcontents = 'contents:true,';
        }
        else {
            $dbquery="SELECT * FROM immagini WHERE id_image='$rowf[popup]'";
            $rowrs = $connh->Execute($dbquery);
            $rowp = $rowrs->fields;
            if ($rowp[id_user] == 'superuser')
                $path = "pix/$rowp[nome]";
            else
                $path = "pix/$rowp[id_user]/$rowp[nome]";
            $size = GetImageSize($path);
            $modalcontents = '';
        }
        
        $dbquery="SELECT * FROM popup WHERE id='$rowf[popup]'";
        $rowrs = $connh->Execute($dbquery);
        $poprow = $rowrs->fields;

       if ($poprow[margini] == '')
            $poprow[margini] = "100";

        if (trim($poprow['didascalia']) != '')
            $link_title = $poprow['didascalia'];
        elseif (trim($rowf['title']) != '')
            $link_title = $rowf['title'];
        elseif (trim($rowf['longdesc']) != '')
            $link_title = $rowf['longdesc'];
        elseif (trim($rowf['alt']) != '')
            $link_title = $rowf['alt'];
        else
            $link_title = $rowf['nome'];

        $subst .=
            "<div style=\"display:none\"><div id=\"modal". $rowp['id_image'] . "\" >" . "<img src=\"$path\"  />" .  "</div>\n</div>\n" .
            "<a href=\"#\" class=\"" . $poprow["txtcolor"] . "\" id=\"" . $poprow["txtcolor"] . $rowf['id_image'] . "\">\n" .
            "<img src=\"$src\" width=\"$rowf[width]\" height=\"$rowf[height]\" ";

    }
    else $subst = "<img src=\"$src\" width=\"$rowf[width]\" height=\"$rowf[height]\" ";

    $str_style = '';
    if ($rowf[align] == 'top' || $rowf[align] == 'bottom' || $rowf[align] == 'middle')
        $str_style .= "vertical-align:$rowf[align];";
    elseif ($rowf[align] == 'left' || $rowf[align] == 'right')
        $str_style .= "float:$rowf[align];";
    if ($rowf[hspace] != '') $str_style .= "margin-left:$rowf[hspace]px;margin-right:$rowf[hspace]px;";
    if ($rowf[vspace] != '') $str_style .= "margin-bottom:$rowf[vspace]px;margin-top:$rowf[vspace]px;";
    if ($rowf[border] != '') $str_style .= "border:$rowf[border]px solid black;";
    if ($rowf[title] != '') $subst .= "title=\"$rowf[title]\" ";
    if ($rowf[longdesc] != '') $subst .= "longdesc=\"$rowf[longdesc]\"  ";
    $subst .= "alt=\"$rowf[alt]\" ";
    if ($str_style != '') $subst .= "style=\"$str_style\"";

    $GLOBALS['photos'][] = $rowf['id_image'];

    $image_index = 0;
    for ($i = 0; $i <= count($GLOBALS['photos']); $i++) {
        if ($rowf['id_image'] == $GLOBALS['photos'][$i])
            $image_index++;
    }

    if ($image_index <= 1) $image_index = '';
    else $image_index = '_'.$image_index;

    $nomea = explode('.', $rowf['nome']);
    $nome = $nomea[0];
    $subst .= " id=\"".$nome.$image_index."\"";
    $subst .= " />\n";


    if($rowf[popup]!='' && $rowf[popup]!='0')
            $subst .=
                "</a><script type=\"text/javascript\">$('#" . $poprow["txtcolor"] . $rowf['id_image']."').colorbox({inline: true, href: '#modal" . $rowp['id_image'] . "', transition: 'none'});</script><noscript><p>".err_js_not_supported."</p></noscript>";

    // una furbata finale
    if ($wantpath)
        $subst = $src;

    return $subst;
}

/**
 ** tag: image
 ** desc: inserisce un oggetto immagine
 ** opt: id id della foto da stampare
 ** opt: alias nome assegnato alla foto, modo alternativo a "id" per richiamare l'immagine
 ** opt: attributi tutti gli attributi classici dell'html (title, class..) andranno a ricoprire le impostazioni salvate da pannello
 **/
function image($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if ($img = new core_image($options))
        return $img->render();
}

/**
 ** tag: metaname
 ** desc: da inserire all'interno della sezione head del template, stampa i metaname gestiti
 ** option get nome del metaname da richiamare
 **/
function metaname($connh, $row, &$PRISCILLA_SESSION, $options)
{
    $dbquery = "SELECT * FROM metaname WHERE id='".$row['id']."'";
    $rs = $connh->Execute($dbquery) or die("ERRORE: $dbquery<br />".$connh->ErrorMsg()); 
    $r = $rs->fields;
 

    // metaname tradotti
    if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG) {

        $dbquery = "SELECT `dctitle`, `description`, `keywords` FROM `metaname_lang" . $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') . "` WHERE `id` = " . $row["id"] . " LIMIT 1";

        $rsmetal = $connh->Execute($dbquery);

        if ($rsmetal && $rsmetal->RecordCount() == 1) {
            $rsm = $rsmetal->fields;
            $r["dctitle"] = $rsm["dctitle"];
            $r["description"] = $rsm["description"];
            $r["keywords"] = $rsm["keywords"];
        }
    }
 
    if (trim($options["get"]) != "")
        return $r[$options["get"]];
 
    if ($r[keywords] == '') $r[keywords] = $row[sezione];
    $subst .= "<meta name=\"keywords\" content=\"$r[keywords]\" />\n";

    if ($r[dctitle] == '') $r[dctitle] = $row[sezione];
    $subst .= "<meta name=\"dc.title\" content=\"$r[dctitle]\" />\n";

    if ($r[description] == '') $r[description] = $row[sezione];
    $subst .= "<meta name=\"description\" content=\"$r[description]\" />\n";

//    $subst .= "<meta http-equiv=\"content-type\" content=\"text/html; charset=".PRISCILLA_CHARSET."\" />\n";

    if (trim($r[author]) == '') {
        $rsu = $connh->execute("select nome, cognome from user where username='".$row['id_user']."'");
        $r[author] = $rsu->fields['nome']." ".$rs->fields['cognome'];
    }
    
    if (trim($r[author]) != '')
	$subst .= "<meta name=\"author\" content=\"$r[author]\" />\n";

    if($r[refresh]!='' and $r[check_refresh]=='si') $subst.="<meta http-equiv=\"refresh\" content=\"$r[refresh]\" />\n";
    if($r[robots]!='' and $r[check_robots]=='si') $subst.="<meta name=\"robots\" content=\"$r[robots]\" />\n";
    if($r[revisitafter]!='' and $r[check_revisitafter]=='si') $subst.="<meta name=\"revisit-after\" content=\"$r[revisitafter]\" />\n";
    if($r[pragma]!='' and $r[check_pragma]=='si') $subst.="<meta http-equiv=\"pragma\" content=\"$r[pragma]\" />\n";
    if($r[rating]!='' and $r[check_rating]=='si') $subst.="<meta name=\"rating\" content=\"$r[rating]\" />\n";
    if($r[distribution]!='' and $r[check_distribution]=='si') $subst.="<meta http-equiv=\"distribution\" content=\"$r[distribution]\" />\n";
    if($r[copyright]!='' and $r[check_copyright]=='si') $subst.="<meta name=\"copyright\" content=\"$r[copyright]\" />\n";
    if($r[replyto]!='' and $r[check_replyto]=='si') $subst.="<meta name=\"reply-to\" content=\"$r[replyto]\" />\n";
    if($r[creation_date]!='' and $r[check_creationdate]=='si') $subst.="<meta name=\"creation_date\" content=\"$r[creation_date]\" />\n";
    if($r[generator]!='' and $r[check_generator]=='si') $subst.="<meta name=\"generator\" content=\"$r[generator]\" />\n";

    return $subst;
}

/**
 ** tag: comments
 ** desc: gestione dei commenti per pagina. deve esistere per la tabella di contenuto associata alla pagina la relativa tabella dei commenti. Utilizzare lo script tools/script/make_comments.php per crearla.
 **/
function comments($connh, $row, &$PRISCILLA_SESSION, $options)
{
    // file esterno utilizzato: commenti.php

    $tables = $connh->MetaTables();
    if (in_array($row['contenuto']."_comments", $tables)) {
        $subst = "<div class=\"comments_box\" name=\"page_comments\">";
    
        if ($PRISCILLA_SESSION->exists('priscilla_comments_msg')) {
            $subst .= $PRISCILLA_SESSION->getvalue('priscilla_comments_msg');
            $PRISCILLA_SESSION->remove('priscilla_comments_msg');
        }

        if ($PRISCILLA_SESSION->exists('priscilla_comments_param')) {
            // prendo eventuali dati già inseriti dall'utente
            $commparam = $PRISCILLA_SESSION->getvalue('priscilla_comments_param');
            $PRISCILLA_SESSION->remove('priscilla_comments_param');
        }

        if (!$_GET['id'])
            $_GET['id'] = 1;

        $subst .= "<form method=\"post\" id=\"comments_form\" action=\"modules/core/lib/commenti.php\">
        <fieldset>
        <input type=\"hidden\" name=\"comment[idp]\" id=\"comment_idp\" value=\"".$_GET['id']."\" />
        <input type=\"hidden\" name=\"action\" id=\"action\" value=\"save\" />
        <input type=\"hidden\" name=\"contenuto\" id=\"contenuto\" value=\"".$row['contenuto']."\" />
        <input type=\"hidden\" name=\"whosend\" id=\"whosend\" value=\"".md5($_SERVER['SERVER_NAME'].PRISCILLA_LOCAL_PATH)."\" />
        <input type=\"hidden\" name=\"delid\" id=\"delid\" />";
        
        $dbquery = "SELECT * FROM ".$row['contenuto']."_comments WHERE id='$id'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
        $num_campi = $rowrs->FieldCount();
    
        $field_info = $connh->MetaColumns($row['contenuto'].'_comments');
    
        for ($i = 0; $i < $num_campi; $i++)
        {
            $field = $rowrs->FetchField($i);
            $type = $rowrs->MetaType($field_info[strtoupper($field->name)]);
            $name = $field->name;
            $len = $field->max_length;
            if ($len < 0) $len = '';
    
            if ($commparam[$name] != '')
                $value = $commparam[$name];
            else 
                $value = $name;
    
            if ($name == 'id' || $name == 'idp' || $type == 'D') ;
            elseif ($type == 'X')
            {
                $subst .= "<div class=\"comments_row\">
                <div class=\"comments_txt\"><label for=\"$name\">$name</label></div>
                <div class=\"comments_input\"><textarea class=\"comments_form\" name=\"comment[$name]\" id=\"$name\" wrap=\"virtual\" onclick=\"javascript:if(this.value=='$value') this.value='';\">$value</textarea></div>
                </div>";
            }
            elseif (ereg('^enum', $field_info[strtoupper($field->name)]->type))
            {
                ereg("\('(.+)'\)", $field_info[strtoupper($field->name)]->type, $match1);
                $tok = explode("','", $match1[1]);
                $subst .= "<div class=\"comments_row\">
                <div class=\"comments_txt\"><label for=\"$name\">$name</label></div>\n
                <div class=\"comments_input\"><select name=\"comment[$name]\" id=\"$name\" size=\"1\" class=\"comments_form\">";
                foreach ($tok as $val)
                {
                    $subst .= "<option value=\"$val\">$val</option>";
                }
                $subst .= "</div>
                </div>";
            }
            else
            {
                $subst .= "<div class=\"comments_row\">
                <div class=\"comments_txt\"><label for=\"$name\">$name</label></div>
                <div class=\"comments_input\"><input class=\"comments_form\" type=\"text\" size=\"24\" maxlength=\"$len\" name=\"comment[$name]\" id=\"$name\" value=\"$value\" onclick=\"javascript:if(this.value=='$value') this.value='';\" /></div>
                </div>";
            }
        }
    
        require_once PRISCILLA_LOCAL_PATH."modules/security/lib/login_captcha.php";
        require_once PRISCILLA_LOCAL_PATH."tools/lang/ita/dialog.diz";

        $random_code = randuid(6);
        $PRISCILLA_SESSION->add('priscilla_img_code', $random_code);
    
        $subst .= "<div class=\"comments_row\">
            <div class=\"comments_txt\"><label for=\"randomcode\">Copia il codice che leggi nell'immagine</label> </div>
            <div class=\"comments_input\"><img src=\"".PRISCILLA_SERVER_PATH."/modules/security/lib/mkimgstamp.php\" title=\"immagine captcha\" alt=\"immagine captcha\" id=\"captchaimg\" /> <input type=\"text\" maxlength=\"6\" size=\"6\" id=\"randomcode\" name=\"randomcode\" class=\"comments_form\" /></div>
        </div>";
    
        $subst .= "<div class=\"comments_submit\">
            <input type=\"submit\" value=\"" . "commenta l'articolo" . "\" id=\"butt_save\" class=\"comments_form\" /></div>
            </fieldset></form>
            </div>";
    
        $rscomm = $connh->Execute("SELECT * FROM ".$row['contenuto']."_comments WHERE idp='".$_GET['id']."'");
        if ($rscomm->RecordCount() > 0) {
            $subst .= "<div class=\"comments_list\">";
            while (!$rscomm->EOF) {
                if (trim($rscomm->fields['nome']) == '')
                    $rscomm->fields['nome'] = 'anonimo';
                if (isset($_COOKIE['login']) && $PRISCILLA_SESSION->exists('login_auth_id') && trim($PRISCILLA_SESSION->getvalue('login_auth_id')) != '' && $PRISCILLA_SESSION->getvalue('login_auth_id') == md5($_COOKIE['login'].$_COOKIE['firma']))
                    $subst .= "<div class=\"insert_voice\"><a style=\"cursor:pointer\" onclick=\"document.getElementById('action').value='delete';document.getElementById('delid').value='".$rscomm->fields['id']."';document.getElementById('comments_form').submit();\">".dialog_gen_del."</a></div>";
                $subst .= "<div class=\"comments_list_row\">Commento inserito da <p class=\"comments_list_name\">".$rscomm->fields['nome']."</p><p class=\"comments_list_email\"> ".$rscomm->fields['email']."</p>\n<p class=\"comments_list_text\">".$rscomm->fields['commento']."</p></div>";
                $rscomm->MoveNext();
            }
            $subst .= "</div>";
        }
    }
    else if (isset($_COOKIE['login']) && $PRISCILLA_SESSION->exists('login_auth_id') && trim($login_auth_id) != '' && $login_auth_id == md5($_COOKIE['login'].$firma))
        $subst .= "<strong>La pagina non &egrave; abilitata alla scrittura dei commenti!</strong>";

    return $subst;
}

/**
 ** tag: countcomments
 ** desc: ritorna il numero di commenti inseriti per la pagina
 **/
function countcomments($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if ($options['id']) {
        $idp = $options['id'];
        $rsn = $connh->Execute("SELECT contenuto FROM node WHERE id='".$idp."'");
        $tblcont = $rsn->fields['contenuto'];
    }
    else {
        $idp = $row['id'];
        $tblcont = $row['contenuto'];
    }
    
    if (in_array($tblcont."_comments", $connh->MetaTables())) {
        $rs = $connh->Execute("SELECT COUNT(id) AS c FROM ".$tblcont."_comments WHERE idp='".$idp."'");
        return $rs->fields['c'];
    }
}

/**
 ** tag: collabora
 ** desc: apre il form per inviare collaborazioni al sito specifico
 ** opt: content il nome della tabella di contenuti da utilizzare senza il suffisso '_content' (default base)
 ** opt: nrows sono le righe delle textarea presenti nel content (opzionale, default 11)
 ** opt: sezione opzionale, se presente indica quale campo prendere per assegnare il nome di sezione
 **/

function collabora($connh, $row, &$PRISCILLA_SESSION, $options)
{
    global $vlogin,$vfirma;
    $key = 'Jjf2NSJHeSJqqv729jjh4jkw241GHgrH';

    //if (trim($templang) == '')
    //    $templang = 'ita';
    require "tools/lang/".$GLOBALS['lang']."/dialog.diz";

    if (!$options['content'])
        $options['content'] = 'base';

    if (!$options['nrows'])
        $options['nrows'] = '11';

    $subst = "<div class=\"collabora_box\">";

    if ($PRISCILLA_SESSION->exists('priscilla_collabora_msg'))
        $subst .= $PRISCILLA_SESSION->getvalue('priscilla_collabora_msg');

    $subst .= "<form method=\"post\" action=\"modules/core/lib/collabora.php\"><p>
    <input type=\"hidden\" name=\"whosend\" id=\"whosend\" value=\"".md5($_SERVER['SERVER_NAME'].PRISCILLA_LOCAL_PATH)."\" />";
    if ($options['sezione'] != '') $subst .= "<input type=\"hidden\" name=\"nomesezione\" id=\"nomesezione\" value=\"".$options['sezione']."\" />";
    $dbquery = "SELECT * FROM content_".$options['content']." WHERE id='$id'";

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    $num_campi = $rowrs->FieldCount();

    $field_info = $connh->MetaColumns('content_'.$options['content']);

    $collparam = $PRISCILLA_SESSION->getvalue('priscilla_collabora_param');

    for ($i = 0; $i < $num_campi; $i++)
    {
        $field = $rowrs->FetchField($i);
        $type = $rowrs->MetaType($field_info[strtoupper($field->name)]);
        $name = $field->name;
        $len = $field->max_length;
        if ($len < 0) $len = '';

        if ($collparam[$name] != '')
            $value = $collparam[$name];
        else 
            $value = $name;

        if ($name == 'id' || $type == 'D') ;
        elseif ($type == 'X')
        {
            $subst .= "<div class=\"collabora_row\">
            <div class=\"collabora_txt\"><label for=\"$name\">$name</label></div>
            <div class=\"collabora_input\"><textarea class=\"collabora_form\" name=\"data[$name]\" id=\"$name\" cols=\"48\" rows=\"".$options['nrows']."\" wrap=\"virtual\" onclick=\"if(this.value == '$name') this.value='';\">$value</textarea></div>
            </div>";
        }
        elseif (ereg('^enum', $field_info[strtoupper($field->name)]->type))
        {
            ereg("\('(.+)'\)", $field_info[strtoupper($field->name)]->type, $match1);
            $tok = explode("','", $match1[1]);
            $subst .= "<div class=\"collabora_row\">
            <div class=\"collabora_txt\"><label for=\"$name\">$name</label></div>\n
            <div class=\"collabora_input\"><select name=\"data[$name]\" id=\"$name\" class=\"collabora_form\">";
            foreach ($tok as $val)
            {
                $subst .= "<option value=\"$val\">$val</option>";
            }
            $subst .= "</div>
            </div>";
        }
        else
        {
            $subst .= "<div class=\"collabora_row\">
            <div class=\"collabora_txt\"><label for=\"$name\">$name</label></div>
            <div class=\"collabora_input\"><input class=\"collabora_form\" type=\"text\" maxlength=\"$len\" name=\"data[$name]\" id=\"$name\" value=\"$value\" onclick=\"if(this.value == '$name') this.value='';\"/></div>
            </div>";
        }
    }

    require PRISCILLA_LOCAL_PATH."modules/security/lib/login_captcha.php";
    $random_code = randuid(6);
    $PRISCILLA_SESSION->add('priscilla_img_code', $random_code);

    $subst .= "<div class=\"collabora_row\">
        <div class=\"collabora_txt\"><label for=\"randomcode\">Copia il codice che leggi nell'immagine</label> </div>
        <div class=\"collabora_input\"><img src=\"".PRISCILLA_SERVER_PATH."/modules/security/lib/mkimgstamp.php\" title=\"immagine captcha\" alt=\"immagine captcha\" id=\"captchaimg\"/><input type=\"text\" maxlength=\"6\" size=\"6\" id=\"randomcode\" name=\"randomcode\" class=\"collabora_form\"></div>
    </div>";

    $subst .= "<div class=\"collabora_submit_row\">
        <input type=\"hidden\" name=\"id_parent\" id=\"id_parent\" value=\"$row[id]\" />
        <input type=\"hidden\" name=\"contenuto\" id=\"contenuto\" value=\"".$options['content']."\" />
        <input type=\"hidden\" name=\"action\" id=\"action\" value=\"save\" />
        <input type=\"submit\" value=\"" . dialog_collab_save_article . "\" id=\"butt_save\" class=\"collabora_form\" /></div>
        </p></form>
        </div>" . dialog_collab_content_end;

    return $subst;
}

/**
 ** tag: formatDate
 ** desc: formatta una data secondo il formato specificato
 ** opt: format stringa di formattazione della data (vedi http://it.php.net/manual/it/function.strftime.php)
 ** opt: date la data da formattare
 **/
function formatDate ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    return date($options['format'], strtotime($options['date']));
}

/**
 ** tag: getArgs
 ** desc: ritorna il valore di un parametro passato a get o post
 ** opt: from get|post default get
 ** opt: key chiave del parametro 
 **/
function getArgs ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['key']))
        return '';

    if (!$options['from'])
        $options['from'] = 'get';

    if ($options['from'] == 'post')
        return $_POST[$options['key']];
    else
        return $_GET[$options['key']];
}

/**
 ** tag: getDefine
 ** desc: ritorna il valore di una costante definita
 ** opt: key nome del define
 **/
function getDefine ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['key']))
        return '';

    eval ('$' . "defvalue = " . $options['key'] . ";");
    return $defvalue;
}

/**
 ** tag: flash
 ** desc: richiama un file flash dato un id
 ** opt: id id del flash da inserire
 ** eg: {flash id="3"}
 **/
function flash ($connh, $row, &$PRISCILLA_SESSION, $options)
{

   $swf = $options["id"];
 
   $query = "SELECT * FROM flash WHERE id='$swf' LIMIT 0,1"; 
   $rowrs = $connh->Execute($query); 
   $rowswf = $rowrs->fields; 
   if ($rowswf[width] == 0) $rowswf[width] = ''; 
   if ($rowswf[height] == 0) $rowswf[height] = ''; 
    
   $flashpath = "attach" . "/" . $rowswf[id_user] . "/flash"; 
   if (file_exists($flashpath."/$rowswf[path]")) 
   { 
       $swfsize = getimagesize($flashpath."/$rowswf[path]"); 
       if ($rowswf[width] == 0) $rowswf[width] = $swfsize[0]; 
       if ($rowswf[height] == 0) $rowswf[height] = $swfsize[1]; 
    
       $subst = "<object type=\"application/x-shockwave-flash\" data=\"$flashpath/$rowswf[path]\" width=\"$rowswf[width]\" height=\"$rowswf[height]\""; 
       if ($rowswf[title] != '') $subst .= " title=\"$rowswf[title]\""; 
       $subst .= ">
               <param name=\"movie\" value=\"$flashpath/$rowswf[path]\" />";

       // ripristinato parametri wmode (ora parametrizzato) e quality che evidentemente si erano persi durante una modifica per accessibilita`
       if (trim($rowswf["quality"]) != "")
            $subst .= "<param name=\"quality\" value=\"" . $rowswf["quality"] . "\" />\n";
       
       if (trim($rowswf["wmode"]) != "")
            $subst .= "<param name=\"wmode\" value=\"" . $rowswf["wmode"] . "\" />\n";

       $subst .= "<img src=\"noflash.jpg\" width=\"$rowswf[width]\" height=\"$rowswf[height]\" alt=\"$rowswf[title]\" /> 
        </object>"; 
   } 

return $subst;
}  

/**
 ** tag: swaplanglabel
 ** desc: produce etichette tradotte
 ** opt: ita
 ** opt: eng
 ** opt: fra
 ** opt: deu
 ** opt: esp
 ** opt: in generale un identificatore di lingua supportata dal sito
 ** opt: occorre fornire la traduzione della label nelle varie lingue supportate del sito
 ** eg: {swaplanglabel ita="pietra" eng="stone"}
 **/
function swaplanglabel ($connh, $row, &$PRISCILLA_SESSION, $options) {

    if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '')
        $lang = $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');
    else
        $lang = "ita";

        $subst = $options[$lang];
return $subst;
}

/**
 ** tag: pagetitle
 ** desc: produce un url con titolo per un id di pagina fornito
 ** opt: id id della pagina di cui si vuole produrre il titolo amico dei motori di ricerca (seo)
 ** eg: {pagetitle id="48"}
 **/
function pagetitle ($connh, $row, &$PRISCILLA_SESSION, $options) {

    $subst = "";

    if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '')
        $lang = $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');
    else
        $lang = "ita";

    $dbquery = "SELECT `contenuto` FROM `node` WHERE `id` = " . $options["id"] . " LIMIT 1";
    $rs = select($dbquery, $connh);
    
    if ($rs && $rs->RecordCount()) {
        if ($lang != "ita" && $lang != "")
            $suffix = "_lang" . $lang;
        else
            $suffix = "";

        $dbquery = "SELECT `titolo` FROM `" . $rs->fields('contenuto') . $suffix . "` WHERE `id` = " . $options["id"] . " LIMIT 1";
        $rsc = select($dbquery, $connh);
        if ($rsc && $rsc->RecordCount())
            return maketitle($options["id"],  seotitle($rsc->fields('titolo')));
    }

return $subst;
}

/**
 ** tag: loadjs
 ** desc: genera il tag per caricare un file javascript
 ** opt: file percorso dello script relativo al dominio del sito
 ** eg: {loadjs file="attach/superuser/docs/js/jquery_page-scroller.js"}
 **/
function loadjs ($connh, $row, &$DATATONIC_SESSION, $options) {

    $src = $options["file"];
    $mtime = @filemtime($src);

$res = <<< EOF
<script type="text/javascript" src="$src?$mtime"></script>
EOF;

return $res;
}

/**
 ** tag: loadcss
 ** desc: genera il tag per caricare un file css
 ** opt: file percorso del foglio di stile al dominio del sito
 ** opt media se non definita default a "all"
 ** eg: {loadcss file="style/default.css"}
 **/
function loadcss ($connh, $row, &$DATATONIC_SESSION, $options) {

    $href = $options["file"];
    $mtime = @filemtime($href);
    if ($options["media"] != "")
        $media = "media=\"" . $options["media"] . "\"";
    else
        $media = "media=\"all\"";

$res = <<< EOF
<link rel="stylesheet" type="text/css" href="$href?$mtime" $media />
EOF;

return $res;
}

/**
 ** tag: login
 ** desc: genera il link che riporta alla pagina di login
 ** opt: desc testo del link, default: "login"
 ** eg: {login}
 ** eg: {login desc="Accesso redazione"}
 **/
function login ($connh, $row, &$DATATONIC_SESSION, $options) {

    if (isset($options["desc"]) && trim($options["desc"]) != "")
        $desc = $options["desc"];
    else
        $desc = "login";
    
return "<a class=\"loginCmd\" href=\"" . PRISCILLA_SERVER_PATH . "login.php" . "\">" . $desc . "</a>\n";
}


/**
 ** tag: pdfgenerator
 ** desc: genera un link che permette di scaricare la pagina in formato PDF
 ** opt: name testo del link, default: "PDF"
 ** eg: {pdfgenerator}
 ** eg: {pdfgenerator name="Scarica pagina in formato PDF"}
 **/
function pdfgenerator ($connh, $row, &$DATATONIC_SESSION, $options) {

    if (isset($options["name"]) && trim($options["name"]))
        $name = $options["name"];
    else
        $name = "PDF";

    if ($options['tree'] == 'true')
        $s_tree="&tree=yes";
    else
        $s_tree = "";

 
return "<a title=\"" . $name . " " . $row['id']  . "\" href=\"modules/core/lib/pdfgen.php?id=$row[id]" . $s_tree . "\" class=\"pdfgenerator\">$name</a>\n";
}

function fromget ($connh, $row, &$DATATONIC_SESSION, $options) {

        return $_GET[$options["name"]];
}

?>
