<?php

require_once "modules/ecal/inc/config.inc.php";


/**
 ** tag: ecal_calevents
 ** desc: tag che si occupa di stampare eventi di calendario; si possono richiamere nel tag loop tutti i campi database che definiscono gli eventi anteponendo il prefisso cal_ al nome del campo
 **
 ** opt: cat_id stampa eventi della categoria di cui si fornisce l'identificativo; fornire all per tutte le categorie; parametro obbligatorio
 ** opt: today yes|no se posto a yes stampa solo gli eventi del giorno corrente
 ** opt: nottoday yes|no decide se includere il giorno corrente
 ** opt: nweeks numero delle settimane nel futuro di cui si vogliono mostrare gli eventi, se specificato ha precedenza su cat_id
 **
 ** eg: <%ecal_calevents cat_id="all"%>
 ** eg: {cal_data} {cal_descrizione}
 ** eg: <%end%>
 **/
function ecal_calevents (&$connh, &$mycontent, $myrisoluzione, &$myPRISCILLA_SESSION, $myoptions, &$mypublisher, $myblocco) {

    if (trim($_GET["cat_id"]) != "")
    	$myoptions["cat_id"] = $_GET["cat_id"];

    if (trim($myoptions["cat_id"]) != "" && $myoptions["cat_id"] != "all")
    	$query_cat = " AND `categoria` = '" . $myoptions["cat_id"] . "'";
    else
        $query_cat = "";

    if ($myoptions["nottoday"] == "yes")
    	$fromop = ">";
    else
    	$fromop = ">=";

    if (is_numeric($_GET["getevent"])) {

    	$dbquery = "SELECT * FROM `ecal_calendar` WHERE id = " . $_GET["getevent"] .  " AND `pub` = 'si' LIMIT 1";
    }
    else if (isset($_GET["cal_i"]) && isset($_GET["cal_t"])) {

        $cal_i = $_GET["cal_i"];
        $cal_t = $_GET["cal_t"];

        if ($cal_t == "day") {
		$dbquery = "SELECT * FROM `ecal_calendar` WHERE (`data` = '$cal_i' OR (`data_end` IS NOT NULL AND `data_end` != '0000-00-00' AND (`data` <= '$cal_i' AND '$cal_i' <= `data_end`))) AND `pub` = 'si' ORDER BY `data` ASC, `ora` ASC";

	    }	    
    }
    else if ($myoptions["today"] == "yes") {
    	$cal_i = date("Y-m-d");
	    $dbquery = "SELECT * FROM `ecal_calendar` WHERE (`data` = '$cal_i' OR (`data_end` IS NOT NULL AND `data_end` != '0000-00-00' AND (`data` <= '$cal_i' AND '$cal_i' <= `data_end`))) AND `pub` = 'si'" . $query_cat . " ORDER BY `data` ASC, `ora` ASC";

    }
    else if (is_numeric($myoptions["nweeks"]) && (int)$myoptions["nweeks"] > 0) {

		$t = time();
		$d = date("d", $t);
		$m = date("m", $t);
		$y = date("Y", $t);

		$today = $y . "-" . $m . "-" . $d;

		$nextdate_t = mktime(0, 0, 0, $m, $d, $y) + 86400 * (int)$myoptions["nweeks"] * 7;
		$nextdate = date("Y-m-d", $nextdate_t);

        	$dbquery = "SELECT * FROM `ecal_calendar` WHERE `data` $fromop '$today' AND `data` <= '$nextdate' AND `pub` = 'si'" . $query_cat . " ORDER BY `data` ASC, `ora` ASC";

    }
    else if ($myoptions["cat_id"] != "") {
        
        $s_limit = "";

        if (is_numeric($myoptions["n_events"])) {
            if ($myoptions["n_events"] == 0)
                $s_limit = "";
            else
                $s_limit = $myoptions["n_events"];


        }
        else
            $s_limit = 10;

        if ($s_limit != "")
            $query_limit = " LIMIT $s_limit";
        else
            $query_limit = "";

        $curr_date = date("Y-m-d");


	$dbquery = "SELECT * FROM `ecal_calendar` WHERE `pub` = 'si' AND (`data` $fromop '$curr_date' OR (`data_end` IS NOT NULL AND `data_end` != '0000-00-00' AND (`data` <= '$curr_date' AND '$curr_date' <= `data_end`))) " . $query_cat . " ORDER BY `data` ASC, `ora` ASC" . $query_limit;


    }
    else
        return;


//    echo "<h1>" . $dbquery . "</h1>";


    $rs = $connh->Execute($dbquery);


    if (!$rs)
        die($connh->ErrorMsg());

    if ($rs->RecordCount())
        while (!$rs->EOF) {
            $row2 = $rs->fields;
            $row = array();

            $a_d = explode("-", $row2["data"]);
	    $a_end = explode("-", $row2["data_end"]);

            $d = $a_d[2] . "-" . $a_d[1] . "-" . $a_d[0];
 	    $d_end = $a_end[2] . "-" . $a_end[1] . "-" . $a_end[0];


	    foreach ($row2 as $k => $v) {
		if ($v == "00:00:00" || $v == "23:59:00")
			$v = "";
		
		if (ereg ("([0-9]{2}):([0-9]{2}):([0-9]{2})", $v, $regs))
			$v = substr($v, 0, 5);

            	$row["cal_" . $k] = $v;

		if (trim($v) == "")
		    $row["cal_" . $k . "_display"] = "none";
		else
		    $row["cal_" . $k . "_display"] = "";
	    }

            $row["cal_data"] = $d;
	    $row["cal_data_end"] = $d_end;

	    if ($d_end != "00-00-0000" && trim($d_end) != "" && $d != $d_end)
	    	$row["cal_data"] = "dal $d al $d_end";

        $mypublisher->publish($myblocco, $myrisoluzione, $row);

        $rs->MoveNext();
    }
}

/**
 ** tag: ecal_catlist
 ** desc: stmapa la lista delle categorie definite nel database
 ** opt:
 **
 ** eg: <%ecal_catlist%>
 ** eg: <a href="index.php?id=67&cat_id={categoria}">{categoria}</a></a><br />
 ** eg: <%end%>
 **/
function ecal_catlist (&$connh, &$mycontent, $myrisoluzione, &$myPRISCILLA_SESSION, $myoptions, &$mypublisher, $myblocco)
{

   $dbquery = "SELECT DISTINCT `categoria` FROM `ecal_calendar` ORDER BY `categoria` ASC";

    $rs = $connh->Execute($dbquery);

    if (!$rs)
        die($connh->ErrorMsg());

    if ($rs->RecordCount())
        while (!$rs->EOF) {
            $row = $rs->fields;

       	    $mypublisher->publish($myblocco, $myrisoluzione, $row);

        $rs->MoveNext();
	}

}

?>
